| OpenNI 2.0

- Main Page
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Members

Classes | Static Public Member Functions
openni::OpenNI Class Reference

`#include <OpenNI.h>`

List of all members.

## Classes

class | DeviceConnectedListener
class | DeviceDisconnectedListener
class | DeviceStateChangedListener

## Static Public Member Functions

static Status | addDeviceConnectedListener (DeviceConnectedListener *pListener)
static Status | addDeviceDisconnectedListener (DeviceDisconnectedListener *pListener)
static Status | addDeviceStateChangedListener (DeviceStateChangedListener *pListener)
static void | enumerateDevices (Array< DeviceInfo > *deviceInfoList)
static const char * | getExtendedError ()
static Status | getLogFileName (char *strFileName, int nBufferSize)
static Version | getVersion ()
static Status | initialize ()
static void | removeDeviceConnectedListener (DeviceConnectedListener *pListener)
static void | removeDeviceDisconnectedListener (DeviceDisconnectedListener *pListener)
static void | removeDeviceStateChangedListener (DeviceStateChangedListener *pListener)
static Status | setLogConsoleOutput (bool bConsoleOutput)
static Status | setLogFileOutput (bool bFileOutput)
static Status | setLogMinSeverity (int nMinSeverity)
static Status | setLogOutputFolder (const char *strLogOutputFolder)
static void | shutdown ()
static Status | waitForAnyStream (VideoStream **pStreams, int streamCount, int *pReadyStreamIndex, int timeout=TIMEOUT_FOREVER)

## Detailed Description

The OpenNI class is a static entry point to the library. It is used by every OpenNI 2.0 application to initialize the SDK and drivers to enable creation of valid device objects.

It also defines a listener class and events that enable for event driven notification of device connection, device disconnection, and device configuration changes.

In addition, it gives access to SDK version information and provides a function that allows you to wait for data to become available on any one of a list of streams (as opposed to waiting for data on one specific stream with functions provided by the VideoStream class)

## Member Function Documentation

static Status openni::OpenNI::addDeviceConnectedListener | ( | DeviceConnectedListener * | pListener | ) | `[inline, static]`

Add a listener to the list of objects that receive the event when a device is connected. See the OpenNI::DeviceConnectedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be added to the list

Returns:
  Status code indicating success or failure of this operation.

static Status openni::OpenNI::addDeviceDisconnectedListener | ( | DeviceDisconnectedListener * | pListener | ) | `[inline, static]`

Add a listener to the list of objects that receive the event when a device is disconnected. See the OpenNI::DeviceDisconnectedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be added to the list

Returns:
  Status code indicating success or failure of this operation.

static Status openni::OpenNI::addDeviceStateChangedListener | ( | DeviceStateChangedListener * | pListener | ) | `[inline, static]`

Add a listener to the list of objects that receive the event when a device's state changes. See the OpenNI::DeviceStateChangedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be added to the list

Returns:
  Status code indicating success or failure of this operation.

static void openni::OpenNI::enumerateDevices | ( | Array< DeviceInfo > * | deviceInfoList | ) | `[inline, static]`

Fills up an array of DeviceInfo objects with devices that are available.

Parameters:

  [in,out] | deviceInfoList | An array to be filled with devices.

static const char* openni::OpenNI::getExtendedError | ( |  | ) | `[inline, static]`

Retrieves the calling thread's last extended error information. The last extended error information is maintained on a per-thread basis. Multiple threads do not overwrite each other's last extended error information.

The extended error information is cleared on every call to an OpenNI method, so you should call this method immediately after a call to an OpenNI method which have failed.

static Status openni::OpenNI::getLogFileName | ( | char * | strFileName,
|  | int | nBufferSize
| ) |  | `[inline, static]`

Get current log file name

Parameters:

  char | * strFileName [out] returned file name buffer
  int | nBufferSize [in] Buffer size

Return values:

  STATUS_OK | Upon successful completion.
  STATUS_ERROR | Upon any kind of failure.

static Version openni::OpenNI::getVersion | ( |  | ) | `[inline, static]`

Returns the version of OpenNI

static Status openni::OpenNI::initialize | ( |  | ) | `[inline, static]`

Initialize the library. This will load all available drivers, and see which devices are available It is forbidden to call any other method in OpenNI before calling initialize().

static void openni::OpenNI::removeDeviceConnectedListener | ( | DeviceConnectedListener * | pListener | ) | `[inline, static]`

Remove a listener from the list of objects that receive the event when a device is connected. See the OpenNI::DeviceConnectedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be removed from the list

Returns:
  Status code indicating the success or failure of this operation.

static void openni::OpenNI::removeDeviceDisconnectedListener | ( | DeviceDisconnectedListener * | pListener | ) | `[inline, static]`

Remove a listener from the list of objects that receive the event when a device is disconnected. See the OpenNI::DeviceDisconnectedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be removed from the list

Returns:
  Status code indicating the success or failure of this operation.

static void openni::OpenNI::removeDeviceStateChangedListener | ( | DeviceStateChangedListener * | pListener | ) | `[inline, static]`

Remove a listener from the list of objects that receive the event when a device's state changes. See the OpenNI::DeviceStateChangedListener class for details on utilizing the events provided by OpenNI.

Parameters:

  pListener | Pointer to the Listener to be removed from the list

Returns:
  Status code indicating the success or failure of this operation.

static Status openni::OpenNI::setLogConsoleOutput | ( | bool | bConsoleOutput | ) | `[inline, static]`

Configures if log entries will be printed to console.

Parameters:

  const | OniBool bConsoleOutput [in] TRUE to print log entries to console, FALSE otherwise.

Return values:

  STATUS_OK | Upon successful completion.
  STATUS_ERROR | Upon any kind of failure.

static Status openni::OpenNI::setLogFileOutput | ( | bool | bFileOutput | ) | `[inline, static]`

Configures if log entries will be printed to file.

Parameters:

  const | OniBool bConsoleOutput [in] TRUE to print log entries to file, FALSE otherwise.

Return values:

  STATUS_OK | Upon successful completion.
  STATUS_ERROR | Upon any kind of failure.

static Status openni::OpenNI::setLogMinSeverity | ( | int | nMinSeverity | ) | `[inline, static]`

Set minimum severity for log produce

Parameters:

  const | char * strMask [in] Logger name
  int | nMinSeverity [in] Logger severity

Return values:

  STATUS_OK | Upon successful completion.
  STATUS_ERROR | Upon any kind of failure.

static Status openni::OpenNI::setLogOutputFolder | ( | const char * | strLogOutputFolder | ) | `[inline, static]`

Change the log output folder

Parameters:

  const | char * strLogOutputFolder [in] log required folder

Return values:

  STATUS_OK | Upon successful completion.
  STATUS_ERROR | Upon any kind of failure.

static void openni::OpenNI::shutdown | ( |  | ) | `[inline, static]`

Stop using the library. Unload all drivers, close all streams and devices. Once shutdown was called, no other calls to OpenNI is allowed.

static Status openni::OpenNI::waitForAnyStream | ( | VideoStream ** | pStreams,
|  | int | streamCount,
|  | int * | pReadyStreamIndex,
|  | int | timeout = `TIMEOUT_FOREVER`
| ) |  | `[inline, static]`

Wait for a new frame from any of the streams provided. The function blocks until any of the streams has a new frame available, or the timeout has passed.

Parameters:

  [in] | pStreams | An array of streams to wait for.
  [in] | streamCount | The number of streams in `pStreams`
  [out] | pReadyStreamIndex | The index of the first stream that has new frame available.
  [in] | timeout | [Optional] A timeout before returning if no stream has new data. Default value is TIMEOUT_FOREVER.

The documentation for this class was generated from the following file:

- OpenNI.h